/*
Tank Wars DS PC client

All code written by Daniel Jenkins 2008 other than
openGL Template file (modified by Daniel Jenkins)
originally written by Jeff Molofee
*/

#include "twPCClient.h"

twProtocol myTank;



void twSendData(void);
int drawGLScene( GLvoid );

// handle variables declared as static so that their values are not destroyed when this function ends 
int sHandle = 0;// For holding the file descriptors of the sockets created 
struct hostent *server;					// for storing details about the server machine
struct sockaddr_in lSOCK; 				// local socket info 
struct in_addr h_addr; 					// host is a internet address structure

/* function to release/destroy our resources and restoring the old desktop */
void Quit( int returnCode )
{
    /* clean up the window */
    SDL_Quit( );

    /* and exit appropriately */
    exit( returnCode );
}

/* function to reset our viewport after a window resize */
int resizeWindow( int width, int height )
{
    /* Height / width ration */
    GLfloat ratio;

    /* Protect against a divide by zero */
    if ( height == 0 )
	height = 1;

    ratio = ( GLfloat )width / ( GLfloat )height;

    /* Setup our viewport. */
    glViewport( 0, 0, ( GLsizei )width, ( GLsizei )height );

    /* change to the projection matrix and set our viewing volume. */
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity( );

    /* Set our perspective */


    gluPerspective( 138.0f, ratio, 0.1f, 100.0f );


    /* Make sure we're chaning the model view and not the projection */
    glMatrixMode( GL_MODELVIEW );

    /* Reset The View */
    glLoadIdentity( );

    return( TRUE );
}

/* function to handle key press events */
void handleKeyPress( SDL_keysym *keysym )
{

Uint8 * keystate = SDL_GetKeyState(NULL);

if(keystate[SDLK_UP]){
         myTank.Y += 2;
	if(myTank.Y > 255)
	myTank.Y = 255;
	if(myTank.Y < 0)
	myTank.Y = 0;
	twSendData();
	drawGLScene( );
}

if(keystate[SDLK_DOWN]){
 	 myTank.Y -= 2;
	if(myTank.Y > 255)
	myTank.Y = 255;
	if(myTank.Y < 0)
	myTank.Y = 0;
	twSendData();
	drawGLScene( );
}

if(keystate[SDLK_LEFT]){
        myTank.X -= 2;
	if(myTank.X > 192)
	myTank.X = 192;
	if(myTank.X < 0)
	myTank.X = 0;
	twSendData();
	drawGLScene( );
}


if(keystate[SDLK_RIGHT]){
       	myTank.X += 2;
	if(myTank.X > 255)
	myTank.X = 255;
	if(myTank.X < 0)
	myTank.X = 0;
	twSendData();
	drawGLScene( );
}

if(keystate[SDLK_ESCAPE]){
Quit( 0 );
}


    return;
}

/* general OpenGL initialization function */
int initGL( GLvoid )
{

    /* Enable smooth shading */
    glShadeModel( GL_SMOOTH );

    /* Set the background black */
    glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );

    /* Depth buffer setup */
    glClearDepth( 1.0f );

    /* Enables Depth Testing */
    glEnable( GL_DEPTH_TEST );

    /* The Type Of Depth Test To Do */
    glDepthFunc( GL_LEQUAL );

    /* Really Nice Perspective Calculations */
    glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );

    return( TRUE );
}

/* Here goes our drawing code */
int drawGLScene( GLvoid )
{
    /* Clear The Screen And The Depth Buffer */
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

    glLoadIdentity();
    
	int userID;
	int X,Y;
	
		glLoadIdentity();
		X = myTank.X;
		Y = myTank.Y;
		userID = myTank.userID;
		//translate to origin
			

		// translate to player location
		glTranslatef((X*2)-256, (Y*2)-256, -100.0);
					
		// draw box representing player
		glColor3f(1.0/userID+1, 1.0/userID+1, 1.0/userID+10);
		glScalef(10.0,10.0,10.0);
		glBegin(GL_LINES);
		glVertex3f(0.5,0.5,0);
		glVertex3f(-0.5,-0.5,0);
		glVertex3f(0.5,-0.5,0);
		glVertex3f(-0.5,0.5,0);
		glEnd();


			
	

   
    /* Draw it to the screen */
    SDL_GL_SwapBuffers( );


    return(TRUE);
}

int openGLinit()
{
    /* Flags to pass to SDL_SetVideoMode */
    int videoFlags;
    /* main loop variable */
    int done = FALSE;
    /* used to collect events */
    SDL_Event event;
    /* this holds some info about our display */
    const SDL_VideoInfo *videoInfo;
    /* whether or not the window is active */
    int isActive = TRUE;

    /* initialize SDL */
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
	{
	    fprintf( stderr, "Video initialization failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}

    /* Fetch the video info */
    videoInfo = SDL_GetVideoInfo( );

    if ( !videoInfo )
	{
	    fprintf( stderr, "Video query failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}

    /* the flags to pass to SDL_SetVideoMode */
    videoFlags  = SDL_OPENGL;          /* Enable OpenGL in SDL */
    videoFlags |= SDL_GL_DOUBLEBUFFER; /* Enable double buffering */
    videoFlags |= SDL_HWPALETTE;       /* Store the palette in hardware */
    videoFlags |= SDL_RESIZABLE;       /* Enable window resizing */

    /* This checks to see if surfaces can be stored in memory */
    if ( videoInfo->hw_available )
	videoFlags |= SDL_HWSURFACE;
    else
	videoFlags |= SDL_SWSURFACE;

    /* This checks if hardware blits can be done */
    if ( videoInfo->blit_hw )
	videoFlags |= SDL_HWACCEL;

    /* Sets up OpenGL double buffering */
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

    /* get a SDL surface */
    surface = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,
				videoFlags );

    /* Verify there is a surface */
    if ( !surface )
	{
	    fprintf( stderr,  "Video mode set failed: %s\n", SDL_GetError( ) );
	    Quit( 1 );
	}

    /* initialize OpenGL */
    initGL( );

    /* resize the initial window */
    resizeWindow( SCREEN_WIDTH, SCREEN_HEIGHT );

    /* wait for events */
    while ( !done )
	{
	    /* handle the events in the queue */

	    while ( SDL_PollEvent( &event ) )
		{
		    switch( event.type )
			{
			case SDL_ACTIVEEVENT:
			    /* Something's happend with our focus
			     * If we lost focus or we are iconified, we
			     * shouldn't draw the screen
			     */
			    if ( event.active.gain == 0 )
				isActive = FALSE;
			    else
				isActive = TRUE;
			    break;			    
			case SDL_VIDEORESIZE:
			    /* handle resize event */
			    surface = SDL_SetVideoMode( event.resize.w,
							event.resize.h,
							16, videoFlags );
			    if ( !surface )
				{
				    fprintf( stderr, "Could not get a surface after resize: %s\n", SDL_GetError( ) );
				    Quit( 1 );
				}
			    resizeWindow( event.resize.w, event.resize.h );
			    break;
			case SDL_KEYDOWN:
			    /* handle key presses */
   			handleKeyPress( &event.key.keysym );
			break;
			
			case SDL_QUIT:
			    /* handle quit requests */
			    done = TRUE;
			    break;
			default:
			    break;
			}
		}

		
	    /* draw the scene */
	    drawGLScene( );
	}

    /* clean ourselves up and exit */
    Quit( 0 );

    /* Should never get here */
    return( 0 );
}

void twSendData(void)
{

twProtocol temp;
memcpy((void*)&temp,(void*) &myTank, sizeof(myTank));

// set serverPC port number to serverin port
lSOCK.sin_port = htons(SERVERIN);
int sentBytes = 0;
// send packet of data
if((sentBytes = sendto(sHandle, &temp, sizeof(temp), 0, (struct sockaddr*) &lSOCK, sizeof(lSOCK)) != sizeof(twProtocol)))
	printf("error sending data to server %d\n", sentBytes);
//else
// 	iprintf("sent data to server OK\n", sentBytes);

}




int main(int argc, char *argv[])
{

memset(&h_addr, 0, sizeof(h_addr)); 


if(argc != 2)
{
	cout << "Please enter destination computer IP or name\n";
	exit(EXIT_FAILURE);

}

// DNS resolving of target PC
if ((server = gethostbyname(argv[1])) == NULL)
	{
		cout << "\nerror resolving DNS\n";
		return -1;
	}


// Socket Setup UDP
/*----------------------------------------------------------------------------------------------*/
if ((sHandle = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0) //  making a socket and using the IP protocol(AF_INET) and UDP(SOCK_STREAM), storing its number in inSHANDLE 


cout << "\nInitial Socket Setup\n";


// setting up our information for the server - authport
memset(&lSOCK, 0, sizeof(lSOCK)); 	// sets all the memory values of lSOCK to be 0 
lSOCK.sin_family = AF_INET; 		
lSOCK.sin_port = htons(AUTHPORT);	// setting the port 
lSOCK.sin_addr.s_addr = inet_addr(inet_ntoa(*(struct in_addr*)server->h_addr));	// set target IP address

// sent authorisation packet to server
unsigned int ret = 0;
char buffer[] = "ADDME";

if((ret = sendto(sHandle, (const void*)buffer, strlen(buffer), 0, (const sockaddr*)&lSOCK, sizeof(lSOCK))) != strlen(buffer))
{
	cout << "error sending auth request \n";
	exit(EXIT_FAILURE);
}

// wait for ack packet before continuing!? 
	int userID = 0, rVal = 0;
	int sizelSOCK = sizeof(lSOCK);
	lSOCK.sin_port = htons(SERVEROUT); // set port of incoming data to serverout
	if((rVal = recvfrom(sHandle, &userID, sizeof(int), 0, (struct sockaddr*) &lSOCK,(socklen_t*) &sizelSOCK) < 0))
	{
		printf("Error receiving ACK packet from server \n");
		exit(EXIT_FAILURE);
	}
	else
	{
		printf("Received ACK. UserID: %d\n", userID);
		myTank.userID = userID;
	}


// Run main while loop
openGLinit();


return 0;

}


