#ifndef __TWCOMM_H__
#define __TWCOMM_H__

#include <iostream>
#include <pthread.h>	//for POSIX threads API
#include <stdlib.h>
#include <string>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>
#include <errno.h>
#include "twProtocol.h"

//This is the size of the data to send over sockets
#define MSGSIZE 501
//This is the port that the server binds to and listens for connections
#define AUTHPORT 9779 
#define INPORT 9780 
#define OUTPORT 9781

using namespace std;


int twSetupSockets(string compName); 		// Sets up sockets for receiving, sending and requests (ports 9779, 9780, 9781) (-1 = fail)
void *twRunAuthThread(void* arg); 		// Sets up and runs thread listening for incoming connections
void *twRunRecvThread(void* arg);		// Sets up and runs thread for output data to clients
int twSendACK(struct sockaddr_in*, int userID);	// Sends an acknowledgement to the DS that it has been added to database. Sends DS its userID
// int twSendData(targetPC, data);		// Sends data to designated PC (-1 = fail)


#endif

