#include "twDatabase.h"


extern int twAddToGroup(int, int);		
extern int twCalcGroup(twUser* user);	

// global variable to increment and keep track of users
int totalUsers = 0;
// global variables for double linked list of twUser objects

// Vector to store dynamic list of twUsers
vector<twUser*> twUserDB;

// twUser class functions

twUser::twUser() // main constructor
{
userID = 0;
posX = 128;
posY = 128;
subGroup = 0;
}

twUser::~twUser() 
{
cout << "twUser destructor called" << endl;
}

// returns user's position
int twUser::getX(void){return (posX);}
int twUser::getY(void){return (posY);}

// sets users position
void twUser::setX(int X){posX = X;}
void twUser::setY(int Y){posY = Y;}

// get and set users network info
void twUser::setSockInfo(struct sockaddr_in *dsClientInfo)
{
// use memcopy to copy data from shared variable DO NOT ALTER SHARED VARIABLE
memcpy((void*)&sockInfo, (void*)dsClientInfo, sizeof(sockaddr_in));
}
void twUser::getSockInfo(struct sockaddr_in *tempSockInfo)
{
// use memcopy to copy data from shared variable DO NOT ALTER SHARED VARIABLE
memcpy((void*)tempSockInfo, (void*)&sockInfo, sizeof(sockaddr_in));
}


// get userID
int twUser::getID(void){return (userID);}
void twUser::setID(int ID){userID = ID;}

// get and set subGroup TODO 
int twUser::getSubGroup(void){return subGroup;};
void twUser::setSubGroup(int value){subGroup = value;};

// // Starts linked list of user objects (loads user info into memory) TODO  needed???
// void twInitUserDB(void)
// {
// baseUser = new twUser;
// memset(baseUser, 0, sizeof(twUser));
// cout << "User database Initialised" << endl;
// }

// creates object of twUser for the new ds client, and adds it to array TODO	
int twAddUser(struct sockaddr_in * info)
{
// create new twUser object
twUser *newUser = new twUser;
// set data
newUser->setSockInfo(info);
newUser->setID(totalUsers);
totalUsers++;
// push_back onto vector list 
twUserDB.push_back(newUser);


// calculate subgroup

int subGrp = twCalcGroup(newUser);
twAddToGroup(subGrp, (newUser->getID()));

cout << "Added userID: " << newUser->getID() << " to Subscription group " << subGrp << endl;

return(newUser->getID());

}


// removes user from list - destructor?
int twRemoveUser(int ID)
{
unsigned int i = 0;
unsigned int tempIndex = 0;
int foundFlag = 1;

// iterate through users and 
for(i=0;i<twUserDB.size();i++)
{
	// if current userid matches requested userid
	if((twUserDB[i]->getID()) == ID)
	{
	tempIndex = i;
	foundFlag = 1;
	}
	
}
	
//delete dynamic object and erase entry 
if(foundFlag == 1)
{
delete twUserDB[tempIndex];
twUserDB.erase(twUserDB.begin()+tempIndex);
}

return 0;


}

int twCheckClientIP(struct sockaddr_in* newClient)// returns 0 if client is in database, 1 if not in database, -1 if fail
{
unsigned int i = 0;
int foundFlag = 0;
string newClientIP = inet_ntoa(newClient->sin_addr);
struct sockaddr_in tempSock;
string currUserIP;

// iterate through users and check if the new client already exists
for(i=0;i<twUserDB.size();i++)
{
	twUserDB[i]->getSockInfo(&tempSock);
	currUserIP = inet_ntoa(tempSock.sin_addr);
	// if newUser IP matches any current userIP - do not add user to server
	if( currUserIP == newClientIP)
	{
	foundFlag = 1;
	}
}

if(foundFlag == 0)
	return 1;

else if(foundFlag == 1)
	return 0;

else
	return -1;

}


int twUpdateUser(int userID,twProtocol *data) // returns -1 on error, 0 otherwise
{
int tempID;
unsigned int i;
int flag = 0;
// iterate through users and find user to update
for(i=0;i<twUserDB.size();i++)
{
	tempID = twUserDB[i]->getID();
	// if user is found then update users position
	if(tempID == userID)
	{
		flag = 1;
		twUserDB[i]->setX(data->X);
		twUserDB[i]->setY(data->Y);
		//Update users subscription group
		twUserDB[i]->setSubGroup((twCalcGroup(twUserDB[i])));
	}
}


if(flag ==1)
	return 0;

else
	return -1;
}


